<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Component communication</title>
    <style>
        .list-products {
            width: 50%;
            float: left;
        }

        .shopping {
            width: auto;
            padding: 20px;
            float: right;
            margin-right: 10%;
            border: 1px solid #CCCCCC;
        }
    </style>
</head>
<body>

<main>
    <ul class="list-products">
        <list-products v-for="product in listProducts"
                       :name="product.name" :price="product.price"></list-products>
    </ul>

    <div class="shopping">
        <shopping-component></shopping-component>
    </div>


</main>


<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
<script>
    const eventBus = new Vue();

    Vue.component('list-products', {
        props: ['name', 'price'],
        template: `<li>
                <p>{{ name }} - ({{ price }})
                <button @click="addShopping(price)">+</button>
                <button @click="removeShopping(price)">-</button>
                </p>
            </li>`,
        methods: {
            addShopping(price) {
                eventBus.$emit('addShopping', price)
            },
            removeShopping(price) {
                eventBus.$emit('removeShopping', price)
            }
        }
    });

    Vue.component('shopping-component', {
        template: `<section>
            <h2>$ {{ total.toFixed(2) }}</h2>
            <h4>{{ count }} products</h4>
        </section>`,

        data() {
            return {
                count: 0,
                total: 0
            }
        },

        created() {
            eventBus.$on('addShopping', (price) => {
                if(this.total >= 0) {
                    this.total += price;
                    this.count++;
                }
            });
            eventBus.$on('removeShopping', (price) => {
                if(this.total > 0) {
                    this.total -= price;
                    this.count--;
                }
            })
        }
    });

    new Vue({
        el: 'main',
        data: {
            listProducts: [
                {name: 'Libro', price: 200},
                {name: 'Silla', price: 42},
                {name: 'Televisor', price: 89},
                {name: 'Teléfono', price: 75},
                {name: 'Portatil', price: 120},
            ]
        }
    });
</script>
</body>
</html>